﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace PojeClient {
    // ある程度消去せずに溜めて，ある程度攻撃できるなら攻撃する
    class AI_ChargeAndFire : Player {
        private int fMyIndex;
        private int fTimeLimit;
        private Action[] fAnswerBox;
        private Random fRand;

        public String getName() {
            return "AI : Charge and Fire I";
        }

        public void newGame(int yourIndex) {
            fRand = new Random(yourIndex + (new Random()).Next());
            fMyIndex = yourIndex;
        }

        public void endGame(int result) {
        }

        public void setParam(int timeLimit, Action[] answerBox) {
            fTimeLimit = timeLimit;
            fAnswerBox = answerBox;
        }

        public void makeAction(object currentState) {
            State state = (State)currentState;
            Board myBoard = state.getBoard(fMyIndex);
            Board oppBoard = state.getBoard(1 - fMyIndex);
            List<Action> possibleActions = myBoard.createPossibleActions();

            // 攻撃をしかける目安
            int FireLimit = 18;
            // 攻撃された時はこれに満たなくても攻撃する
            if (myBoard.getJamInfo().getTotalCount() > 5) FireLimit = 6;
            // 埋まりそうなときも
            if (AITools.getRestCount(myBoard) <16) FireLimit = 6;
            if (AITools.getRestCount(myBoard) < 6) FireLimit = 0;



            // FireLimit個以上攻撃できるならする．そうでないなら適当にくっつくように消さないで置く
            int bestScore = -10000;
            Action bestAction = null;
            foreach (Action a in possibleActions) {
                int score;
                AITool_Result result = AITools.calcTotalGain(myBoard, a, false);   // その手の結果予測
                int connects = AITools.calcConnectCount(myBoard, a);  // その手がどれだけ周りの石と同色か

                if (result.IsVanish == false) {
                    score = 50 * connects + fRand.Next(100);  //消去しない
                } else if (result.Gain + result.JamVanishCount*2 >= FireLimit) {
                    score = 2000 + result.Gain + result.JamVanishCount*2;  // 邪魔珠(x2)合わせて 18個超えてれば発動する
                } else {
                    score = -result.Gain;   //18に満たない消去をしてしまうにしても小さいものがよい
                }
                if (score > bestScore) {
                    bestScore = score;
                    bestAction = a;
                }
            }
            fAnswerBox[0] = bestAction;
            return;
        }
    }
}
