﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace PojeClient {

    // このゲームでは，配珠以外にはランダム性はない．
    // サーバ通信中はサーバが配珠を指定するが，スタンドアロンの場合はクライアントが配珠を決定する．
    class NextGenerator {
        public static Random fRand;

        // 乱数生成器を初期化する
        public static void initRand() {
            fRand = new Random();
        }


        // 最初の6個の配珠の色を生成する．全て同じ色，ではないようにする
        public static int[] createFirstSet(int numberOfStones) {
            int[] nexts = new int[numberOfStones];
            bool same = true;
            for (int i = 0; i < numberOfStones; i++) {
                nexts[i] = fRand.Next(Settings.NumColor) + 1;
                if (nexts[i] != nexts[0]) same = false;
            }
            if (same == true) {
                int i = fRand.Next(numberOfStones);
                nexts[i] = nexts[0] % Settings.NumColor + 1;
            }
            return nexts;
        }

        // 次の2個の配珠の色を生成する．引数セットの中にない色は必ず作る．
        public static int[] createNextSet(int[] lastColors) {
            int[] nexts = new int[2];
            int count = 0;

            // ない色は確実に含める
            for (int c = 1; c <= Settings.NumColor; c++) {
                bool exists = false;
                for (int i = 0; i < lastColors.Length; i++) {
                    if (lastColors[i] == c) exists = true;
                }
                if (exists == false) {
                    nexts[count] = c;
                    count++;
                }
            }

            // 残りは適当に作る
            for (int i = count; i < 2; i++) {
                nexts[i] = fRand.Next(Settings.NumColor) + 1;
            }

            return nexts;
        }


    }
}
